
ddata RefDLL_t {
  RefDLL_t prev;
  RefDLL_t next;
}.

pred points_to<a:RefDLL_t,b:RefDLL_t,c:RefDLL_t> ==
a::RefDLL_t<prev = c,next = b>.

pred DLL_plus<hd:RefDLL_t,p:RefDLL_t,tl:RefDLL_t,n:RefDLL_t> ==
 hd::RefDLL_t<prev = p,next = n> & hd = tl
or (exists x: hd::RefDLL_t<prev = p,next = x> * DLL_plus(x,hd,tl,n)).

pred DLL_plus_rev<hd:RefDLL_t,p:RefDLL_t,tl:RefDLL_t,n:RefDLL_t> ==
 hd::RefDLL_t<prev = p,next = n> & hd = tl
or (exists x: tl::RefDLL_t<prev = x,next = n> * DLL_plus_rev(hd,p,x,tl)).

pred DLL_plus_mid<hd:RefDLL_t,p:RefDLL_t,tl:RefDLL_t,n:RefDLL_t> ==
 hd::RefDLL_t<prev = p,next = n> & hd = tl
or hd::RefDLL_t<prev = p,next = tl> * points_to(tl,n,hd)
or (exists x,y,z: x::RefDLL_t<prev = z,next = y> * DLL_plus(y,x,tl,n) * DLL_plus_rev(hd,p,z,x)).

checkent[valid] DLL_plus_mid(x,null,y,null)
         |- DLL_plus_rev(x,null,y,null).

