
ddata RefGTyp {
  RefGTyp f0;
  RefGTyp f1;
}.

pred one<x:RefGTyp> ==
emp & null != x.

pred Q<y1:RefGTyp> ==
 zero(y1)
or (exists x1: succ1circuit(x1,y1) * Q(x1)).

pred P<x1:RefGTyp> ==
one(x1) * Q(x1).

pred zero<x:RefGTyp> ==
emp & null = x.

pred succ1circuit<x1:RefGTyp,y1:RefGTyp> ==
notg(x1,y1).

pred notg<x:RefGTyp,y:RefGTyp> ==
 zero(x) * one(y)
or one(x) * zero(y).

pred xorg<x:RefGTyp,y:RefGTyp,z:RefGTyp> ==
 zero(x) * zero(y) * zero(z)
or zero(x) * one(y) * one(z)
or one(x) * zero(y) * one(z)
or one(x) * one(y) * zero(z).

pred andg<x:RefGTyp,y:RefGTyp,z:RefGTyp> ==
 zero(x) * zero(z)
or zero(y) * zero(z)
or one(x) * one(y) * one(z).

checksat[sat] P(x0).

