
ddata RefGTyp {
  RefGTyp f0;
  RefGTyp f1;
}.

pred one<x:RefGTyp> ==
emp & null != x.

pred Q<y1:RefGTyp,y2:RefGTyp,y3:RefGTyp,y4:RefGTyp,y5:RefGTyp,y6:RefGTyp,y7:RefGTyp> ==
 zero(y1) * zero(y2) * zero(y3) * zero(y4) * zero(y5) * zero(y6) * zero(y7)
or (exists x1,x2,x3,x4,x5,x6,x7: succ7rec(x1,x2,x3,x4,x5,x6,x7,y1,y2,y3,y4,y5,y6,y7) * Q(x1,x2,x3,x4,x5,x6,x7)).

pred P<x1:RefGTyp,x2:RefGTyp,x3:RefGTyp,x4:RefGTyp,x5:RefGTyp,x6:RefGTyp,x7:RefGTyp> ==
one(x1) * one(x2) * one(x3) * one(x4) * one(x5) * one(x6) * one(x7) * Q(x1,x2,x3,x4,x5,x6,x7).

pred zero<x:RefGTyp> ==
emp & null = x.

pred succ7rec<x1:RefGTyp,x2:RefGTyp,x3:RefGTyp,x4:RefGTyp,x5:RefGTyp,x6:RefGTyp,x7:RefGTyp,y1:RefGTyp,y2:RefGTyp,y3:RefGTyp,y4:RefGTyp,y5:RefGTyp,y6:RefGTyp,y7:RefGTyp> ==
 zero(x1) * one(y1) & x2 = y2 & x3 = y3 & x4 = y4 & x5 = y5 & x6 = y6 & x7 = y7
or succ6rec(x2,x3,x4,x5,x6,x7,y2,y3,y4,y5,y6,y7) * one(x1) * zero(y1).

pred succ6rec<x1:RefGTyp,x2:RefGTyp,x3:RefGTyp,x4:RefGTyp,x5:RefGTyp,x6:RefGTyp,y1:RefGTyp,y2:RefGTyp,y3:RefGTyp,y4:RefGTyp,y5:RefGTyp,y6:RefGTyp> ==
 zero(x1) * one(y1) & x2 = y2 & x3 = y3 & x4 = y4 & x5 = y5 & x6 = y6
or succ5rec(x2,x3,x4,x5,x6,y2,y3,y4,y5,y6) * one(x1) * zero(y1).

pred succ5rec<x1:RefGTyp,x2:RefGTyp,x3:RefGTyp,x4:RefGTyp,x5:RefGTyp,y1:RefGTyp,y2:RefGTyp,y3:RefGTyp,y4:RefGTyp,y5:RefGTyp> ==
 zero(x1) * one(y1) & x2 = y2 & x3 = y3 & x4 = y4 & x5 = y5
or succ4rec(x2,x3,x4,x5,y2,y3,y4,y5) * one(x1) * zero(y1).

pred succ4rec<x1:RefGTyp,x2:RefGTyp,x3:RefGTyp,x4:RefGTyp,y1:RefGTyp,y2:RefGTyp,y3:RefGTyp,y4:RefGTyp> ==
 zero(x1) * one(y1) & x2 = y2 & x3 = y3 & x4 = y4
or succ3rec(x2,x3,x4,y2,y3,y4) * one(x1) * zero(y1).

pred succ3rec<x1:RefGTyp,x2:RefGTyp,x3:RefGTyp,y1:RefGTyp,y2:RefGTyp,y3:RefGTyp> ==
 zero(x1) * one(y1) & x2 = y2 & x3 = y3
or succ2rec(x2,x3,y2,y3) * one(x1) * zero(y1).

pred succ2rec<x1:RefGTyp,x2:RefGTyp,y1:RefGTyp,y2:RefGTyp> ==
 zero(x1) * one(y1) & x2 = y2
or succ1rec(x2,y2) * one(x1) * zero(y1).

pred succ1rec<x1:RefGTyp,y1:RefGTyp> ==
zero(x1) * one(y1).

checksat[sat] P(x0,x1,x2,x3,x4,x5,x6).

