
ddata RefDLL2_t {
  RefDLL2_t prev;
  RefDLL2_t next;
  RefDLL2_t prev2;
  RefDLL2_t next2;
  RefDLL2_t down;
}.

pred DLL1_plus<hd:RefDLL2_t,p:RefDLL2_t> ==
 hd::RefDLL2_t<prev = p,next = null,prev2 = null,next2 = null,down = null>
or (exists x: hd::RefDLL2_t<prev = p,next = x,prev2 = null,next2 = null,down = null> * DLL1_plus(x,hd)).

pred DLL2_plus<hd:RefDLL2_t,p:RefDLL2_t,tl:RefDLL2_t,n:RefDLL2_t> ==
 (exists down_hd: hd::RefDLL2_t<prev = null,next = null,prev2 = p,next2 = n,down = down_hd> * DLL1_plus(down_hd,hd) & hd = tl)
or (exists x,down_hd: hd::RefDLL2_t<prev = null,next = null,prev2 = p,next2 = x,down = down_hd> * DLL1_plus(down_hd,hd) * DLL2_plus(x,hd,tl,n)).

pred DLL2_plus_rev<hd:RefDLL2_t,p:RefDLL2_t,tl:RefDLL2_t,n:RefDLL2_t> ==
 (exists down_hd: hd::RefDLL2_t<prev = null,next = null,prev2 = p,next2 = n,down = down_hd> * DLL1_plus(down_hd,hd) & hd = tl)
or (exists x,down_hd: tl::RefDLL2_t<prev = null,next = null,prev2 = x,next2 = n,down = down_hd> * DLL1_plus(down_hd,tl) * DLL2_plus_rev(hd,p,x,tl)).

checkent[valid] DLL2_plus(hd0,null,tl0,hd1) * DLL2_plus(hd1,tl0,tl1,hd2) * DLL2_plus(hd2,tl1,tl2,hd3) * DLL2_plus(hd3,tl2,tl3,hd4) * DLL2_plus(hd4,tl3,tl4,hd5) * DLL2_plus(hd5,tl4,tl5,hd6) * DLL2_plus(hd6,tl5,tl6,hd7) * DLL2_plus(hd7,tl6,tl7,hd8) * DLL2_plus(hd8,tl7,tl8,hd9) * DLL2_plus(hd9,tl8,tl9,hd10) * DLL2_plus(hd10,tl9,tl10,hd11) * DLL2_plus(hd11,tl10,tl11,hd12) * DLL2_plus(hd12,tl11,tl12,hd13) * DLL2_plus(hd13,tl12,tl13,hd14) * DLL2_plus(hd14,tl13,tl14,hd15) * DLL2_plus(hd15,tl14,tl15,hd16) * DLL2_plus(hd16,tl15,tl16,hd17) * DLL2_plus(hd17,tl16,tl17,hd18) * DLL2_plus(hd18,tl17,tl18,hd19) * DLL2_plus(hd19,tl18,tl19,hd20) * DLL2_plus(hd20,tl19,tl20,null)
         |- (exists hd1,tl1,hd2,tl2,hd3,tl3,hd4,tl4,hd5,tl5,hd6,tl6,hd7,tl7,hd8,tl8,hd9,tl9,hd10,tl10,hd11,tl11,hd12,tl12,hd13,tl13,hd14,tl14,hd15,tl15,hd16,tl16,hd17,tl17,hd18,tl18,hd19,tl19: DLL2_plus_rev(hd0,null,tl0,hd1) * DLL2_plus_rev(hd1,tl0,tl1,hd2) * DLL2_plus_rev(hd2,tl1,tl2,hd3) * DLL2_plus_rev(hd3,tl2,tl3,hd4) * DLL2_plus_rev(hd4,tl3,tl4,hd5) * DLL2_plus_rev(hd5,tl4,tl5,hd6) * DLL2_plus_rev(hd6,tl5,tl6,hd7) * DLL2_plus_rev(hd7,tl6,tl7,hd8) * DLL2_plus_rev(hd8,tl7,tl8,hd9) * DLL2_plus_rev(hd9,tl8,tl9,hd10) * DLL2_plus_rev(hd10,tl9,tl10,hd11) * DLL2_plus_rev(hd11,tl10,tl11,hd12) * DLL2_plus_rev(hd12,tl11,tl12,hd13) * DLL2_plus_rev(hd13,tl12,tl13,hd14) * DLL2_plus_rev(hd14,tl13,tl14,hd15) * DLL2_plus_rev(hd15,tl14,tl15,hd16) * DLL2_plus_rev(hd16,tl15,tl16,hd17) * DLL2_plus_rev(hd17,tl16,tl17,hd18) * DLL2_plus_rev(hd18,tl17,tl18,hd19) * DLL2_plus_rev(hd19,tl18,tl19,hd20) * DLL2_plus_rev(hd20,tl19,tl20,null)).

