
ddata RefGTyp {
  RefGTyp f0;
  RefGTyp f1;
}.

pred BinPath<x:RefGTyp,y:RefGTyp> ==
 emp & x = y
or (exists xp,yp: x::RefGTyp<f0 = xp,f1 = yp> * BinPath(xp,y) & null != x)
or (exists xp,yp: x::RefGTyp<f0 = xp,f1 = yp> * BinPath(yp,y) & null != x).

pred BinTree<x:RefGTyp> ==
 emp
or (exists yp,xp: x::RefGTyp<f0 = yp,f1 = xp> * BinTree(yp) * BinTree(xp) & null != x).

pred BinTreeSeg<x:RefGTyp,y:RefGTyp> ==
 emp & x = y
or (exists xp,yp: x::RefGTyp<f0 = xp,f1 = yp> * BinTreeSeg(xp,y) * BinTree(yp) & null != x)
or (exists xp,yp: x::RefGTyp<f0 = xp,f1 = yp> * BinTree(xp) * BinTreeSeg(yp,y) & null != x).

checkent[valid] BinPath(x,y)
         |- BinTreeSeg(x,y).

