
ddata RefTLL_t {
  RefTLL_t left;
  RefTLL_t right;
  RefTLL_t next;
  RefTLL_t parent;
}.

pred TLL_plus<root:RefTLL_t,pra:RefTLL_t,ll:RefTLL_t,lr:RefTLL_t> ==
 root::RefTLL_t<left = null,right = null,next = lr,parent = pra> & root = ll
or (exists l,r,z: root::RefTLL_t<left = l,right = r,next = null,parent = pra> * TLL_plus(l,root,ll,z) * TLL_plus(r,root,z,lr)).

pred TLL_aux<x:RefTLL_t,p:RefTLL_t,z:RefTLL_t,back:RefTLL_t,top:RefTLL_t,mright:RefTLL_t> ==
 (exists up,r,lr: x::RefTLL_t<left = back,right = r,next = null,parent = up> * TLL_aux(up,p,lr,x,top,mright) * TLL_plus(r,x,z,lr))
or (exists r: x::RefTLL_t<left = back,right = r,next = null,parent = p> * TLL_plus(r,x,z,mright) & x = top).

pred TLL_plus_rev<top:RefTLL_t,p:RefTLL_t,mleft:RefTLL_t,mright:RefTLL_t> ==
 top::RefTLL_t<left = null,right = null,next = mright,parent = p> & top = mleft
or (exists x,up,lr: x::RefTLL_t<left = null,right = null,next = lr,parent = up> * TLL_aux(up,p,lr,x,top,mright) & mleft = x).

checkent[valid] TLL_plus(x,y,u,v)
         |- TLL_plus_rev(x,y,u,v).

