
ddata Refnode {
  Refnode parent;
  Refnode left;
  Refnode right;
  Refnode next;
}.

pred tree<in:Refnode> ==
 (exists p_35,D1_36,r_37,n_38: in::Refnode<parent = p_35,left = D1_36,right = r_37,next = n_38> & null = r_37)
or (exists p_39,l_40,r_41,D2_42: in::Refnode<parent = p_39,left = l_40,right = r_41,next = D2_42> * tree(l_40) * tree(r_41) & null != r_41).

pred tll<in:Refnode,p:Refnode,ll:Refnode,lr:Refnode> ==
 (exists lr_28,p_21,D1_22,l_23: in::Refnode<parent = p_21,left = D1_22,right = l_23,next = lr_28> & null = l_23 & in = ll & lr = lr_28)
or (exists p_29,self_30,ll_31,self_32,z_33,lr_34,l_24,r_25,D2_26,z_27: in::Refnode<parent = p_29,left = l_24,right = r_25,next = D2_26> * tll(l_24,self_30,ll_31,z_27) * tll(r_25,self_32,z_33,lr_34) & null != r_25 & p = p_29 & in = self_30 & ll = ll_31 & in = self_32 & z_33 = z_27 & lr = lr_34).

pred right_nil<in:Refnode> ==
(exists p,l,r,n: in::Refnode<parent = p,left = l,right = r,next = n> & null = r).

pred eright_nil<in:Refnode> ==
(exists p0,l0,r0,n0,p1,l1,r1,n1: in::Refnode<parent = p0,left = l0,right = r0,next = n0> & p0 = p1 & l0 = l1 & r0 = r1 & n0 = n1 & null = r1).

pred right_nnil<in:Refnode> ==
(exists p,l,r,n: in::Refnode<parent = p,left = l,right = r,next = n> * tree(l) * tree(r) & null != r).

pred eright_nnil<in:Refnode> ==
(exists p0,l0,r0,n0,p1,l1,r1,n1: in::Refnode<parent = p0,left = l0,right = r0,next = n0> * tree(l1) * tree(r1) & p0 = p1 & l0 = l1 & r0 = r1 & n0 = n1 & null = r1).

pred enode<in:Refnode,p:Refnode,l:Refnode,r:Refnode,n:Refnode> ==
(exists p0,l0,r0,n0: in::Refnode<parent = p0,left = l0,right = r0,next = n0> & p = p0 & l = l0 & r = r0 & n = n0).

pred etll<in:Refnode,p:Refnode,t:Refnode,r:Refnode> ==
(exists p1,t1: tll(in,p1,r,t1) & p = p1 & t = t1).

pred ltll<in:Refnode,p:Refnode,l:Refnode,r:Refnode,D:Refnode,v:Refnode,t:Refnode> ==
(exists l1: in::Refnode<parent = p,left = l,right = r,next = D> * tll(l,in,v,l1) * tll(r,in,l1,t)).

checkent[valid] right_nil(xprm) & pprm = p & xprm = x & tprm = t
         |- right_nil(xprm) & pprm = p & xprm = x & tprm = t.

