
ddata RefTPP_t {
  RefTPP_t left;
  RefTPP_t right;
  RefTPP_t parent;
}.

pred TPP_plus<x:RefTPP_t,back:RefTPP_t> ==
 x::RefTPP_t<left = null,right = null,parent = back>
or (exists y,z: x::RefTPP_t<left = y,right = z,parent = back> * TPP_plus(y,x) * TPP_plus(z,x)).

pred TPP_aux<x:RefTPP_t,down:RefTPP_t,top:RefTPP_t,b:RefTPP_t> ==
 (exists up,right: x::RefTPP_t<left = down,right = right,parent = up> * TPP_plus(right,x) * TPP_aux(up,x,top,b))
or (exists up,left: x::RefTPP_t<left = left,right = down,parent = up> * TPP_plus(left,x) * TPP_aux(up,x,top,b))
or (exists right: x::RefTPP_t<left = down,right = right,parent = b> * TPP_plus(right,x) & x = top)
or (exists left: x::RefTPP_t<left = left,right = down,parent = b> * TPP_plus(left,x) & x = top).

pred TPP_plus_rev<top:RefTPP_t,b:RefTPP_t> ==
 top::RefTPP_t<left = null,right = null,parent = b>
or (exists x,up: x::RefTPP_t<left = null,right = null,parent = up> * TPP_aux(up,x,top,b)).

checkent[valid] TPP_plus_rev(x,y)
         |- TPP_plus(x,y).

