
ddata RefGTyp {
  RefGTyp f0;
  RefGTyp f1;
}.

pred P<x:RefGTyp> ==
 emp & null = x
or Q(x,x) & null != x.

pred R<x:RefGTyp> ==
P(x) & null != x.

pred Q<x:RefGTyp,y:RefGTyp> ==
 (exists d,c: x::RefGTyp<f0 = d,f1 = c> * P(d) & null = y & null != x)
or (exists d,c: y::RefGTyp<f0 = d,f1 = c> * Q(x,c) & null != y)
or (exists d: S1(x,y,d) & null != x).

pred S1<x:RefGTyp,y:RefGTyp,z:RefGTyp> ==
 (exists c: y::RefGTyp<f0 = x,f1 = c> * z::RefGTyp<f0 = c,f1 = c> * P(z) & null = null)
or (exists c,d: x::RefGTyp<f0 = c,f1 = d> * Q(x,y) & null = c & null = d)
or (exists c,d: S2(c,y,z,c) & null != c).

pred S2<x:RefGTyp,y:RefGTyp,z:RefGTyp,t:RefGTyp> ==
 (exists c: y::RefGTyp<f0 = x,f1 = c> * z::RefGTyp<f0 = c,f1 = x> * P(t) & null = null)
or (exists c,d: x::RefGTyp<f0 = c,f1 = d> * Q(x,y) & null = c & null = d)
or S1(x,y,z) & null = y
or (exists c,d: S3(c,y,z,d,x) & null != c).

pred S3<x:RefGTyp,y:RefGTyp,z:RefGTyp,t:RefGTyp,v:RefGTyp> ==
 (exists c: y::RefGTyp<f0 = x,f1 = c> * z::RefGTyp<f0 = c,f1 = x> * P(t) & null = null)
or (exists c,d: x::RefGTyp<f0 = c,f1 = d> * Q(x,y) & null = c & null = d)
or S1(x,y,z) & null = y
or (exists c,d,e: S2(e,y,z,d) & null != c & null = e).

checksat[sat] R(x0).

